"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("@builder.io/react");
var app_context_1 = require("@builder.io/app-context");
var constants_1 = require("./constants");
var sync_to_algolia_1 = require("./sync-to-algolia");
var create_web_hook_1 = require("./create-web-hook");
react_1.Builder.register('plugin', {
    id: constants_1.pluginId,
    name: 'Algolia',
    settings: [
        {
            name: 'algoliaKey',
            type: 'text',
            defaultValue: true,
        },
        {
            name: 'algoliaAppId',
            type: 'text',
            defaultValue: true,
        },
    ],
    ctaText: 'Save',
    onSave: function (actions) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // update plugin setting
                    return [4 /*yield*/, actions.updateSettings({
                            hasConnected: true,
                        })];
                    case 1:
                        // update plugin setting
                        _a.sent();
                        app_context_1.default.dialogs.alert('Plugin settings saved.');
                        return [2 /*return*/];
                }
            });
        });
    },
});
react_1.Builder.register('app.onLoad', function (_a) {
    var triggerSettingsDialog = _a.triggerSettingsDialog;
    return __awaiter(void 0, void 0, void 0, function () {
        var pluginSettings, hasConnected;
        var _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    pluginSettings = (_b = app_context_1.default.user.organization.value.settings.plugins) === null || _b === void 0 ? void 0 : _b.get(constants_1.pluginId);
                    hasConnected = pluginSettings === null || pluginSettings === void 0 ? void 0 : pluginSettings.get('hasConnected');
                    if (!!hasConnected) return [3 /*break*/, 2];
                    return [4 /*yield*/, triggerSettingsDialog(constants_1.pluginId)];
                case 1:
                    _c.sent();
                    _c.label = 2;
                case 2: return [2 /*return*/];
            }
        });
    });
});
react_1.Builder.register('model.action', {
    name: 'Sync to Algolia',
    showIf: function () {
        return app_context_1.default.user.can('admin');
    },
    onClick: function (model) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, app_context_1.default.dialogs.confirm("This will sync all current and future entries in the \"".concat(model.name, "\" model to Algolia."), 'Continue')];
                    case 1:
                        if (!(_a.sent())) {
                            return [2 /*return*/];
                        }
                        app_context_1.default.globalState.showGlobalBlockingLoadingIndicator = true;
                        return [4 /*yield*/, (0, sync_to_algolia_1.syncToAlgolia)(model.name)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, (0, create_web_hook_1.createWebhook)(model)];
                    case 3:
                        _a.sent();
                        app_context_1.default.globalState.showGlobalBlockingLoadingIndicator = false;
                        return [2 /*return*/];
                }
            });
        });
    },
});
//# sourceMappingURL=plugin.js.map