System.register(['@builder.io/react', '@builder.io/app-context'], function (exports, module) {
    'use strict';
    var Builder, appState;
    return {
        setters: [function (module) {
            Builder = module.Builder;
        }, function (module) {
            appState = module.default;
        }],
        execute: function () {

            /*! *****************************************************************************
            Copyright (c) Microsoft Corporation. All rights reserved.
            Licensed under the Apache License, Version 2.0 (the "License"); you may not use
            this file except in compliance with the License. You may obtain a copy of the
            License at http://www.apache.org/licenses/LICENSE-2.0

            THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
            KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
            WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
            MERCHANTABLITY OR NON-INFRINGEMENT.

            See the Apache Version 2.0 License for specific language governing permissions
            and limitations under the License.
            ***************************************************************************** */

            var __assign = function() {
                __assign = Object.assign || function __assign(t) {
                    for (var s, i = 1, n = arguments.length; i < n; i++) {
                        s = arguments[i];
                        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
                    }
                    return t;
                };
                return __assign.apply(this, arguments);
            };

            function __awaiter(thisArg, _arguments, P, generator) {
                return new (P || (P = Promise))(function (resolve, reject) {
                    function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
                    function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
                    function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
                    step((generator = generator.apply(thisArg, _arguments || [])).next());
                });
            }

            function __generator(thisArg, body) {
                var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
                return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
                function verb(n) { return function (v) { return step([n, v]); }; }
                function step(op) {
                    if (f) throw new TypeError("Generator is already executing.");
                    while (_) try {
                        if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                        if (y = 0, t) op = [op[0] & 2, t.value];
                        switch (op[0]) {
                            case 0: case 1: t = op; break;
                            case 4: _.label++; return { value: op[1], done: false };
                            case 5: _.label++; y = op[1]; op = [0]; continue;
                            case 7: op = _.ops.pop(); _.trys.pop(); continue;
                            default:
                                if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                                if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                                if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                                if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                                if (t[2]) _.ops.pop();
                                _.trys.pop(); continue;
                        }
                        op = body.call(thisArg, _);
                    } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
                    if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
                }
            }

            var pluginId = '@builder.io/plugin-algolia';

            var syncToAlgolia = function (modelName) { return __awaiter(void 0, void 0, void 0, function () {
                var pluginSettings, algoliaKey, algoliaAppId;
                return __generator(this, function (_a) {
                    pluginSettings = appState.user.organization.value.settings.plugins.get(pluginId);
                    algoliaKey = pluginSettings.get('algoliaKey');
                    algoliaAppId = pluginSettings.get('algoliaAppId');
                    fetch("".concat(appState.config.apiRoot(), "/api/v1/algolia-sync/").concat(modelName, "?apiKey=").concat(appState.user.organization.value.id), {
                        method: 'POST',
                        headers: __assign({}, appState.user.authHeaders),
                        body: JSON.stringify({
                            algoliaKey: algoliaKey,
                            algoliaAppId: algoliaAppId,
                        }),
                    });
                    return [2 /*return*/];
                });
            }); };

            var createWebhook = function (model) { return __awaiter(void 0, void 0, void 0, function () {
                var pluginSettings, algoliaKey, algoliaAppId, pluginPrivateKey, newWebhook, existingAlgoliaHookIndex, i, currentHookPath, newHookPath;
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            pluginSettings = appState.user.organization.value.settings.plugins.get(pluginId);
                            algoliaKey = pluginSettings.get('algoliaKey');
                            algoliaAppId = pluginSettings.get('algoliaAppId');
                            return [4 /*yield*/, appState.globalState.getPluginPrivateKey(pluginId)];
                        case 1:
                            pluginPrivateKey = _b.sent();
                            if (!pluginPrivateKey) {
                                return [2 /*return*/];
                            }
                            newWebhook = {
                                meta: {
                                    pluginId: pluginId,
                                },
                                customHeaders: [
                                    {
                                        name: 'Authorization',
                                        value: "Bearer ".concat(pluginPrivateKey),
                                    },
                                ],
                                url: "".concat(appState.config.apiRoot(), "/api/v1/algolia-sync/webhook?algoliaKey=").concat(algoliaKey, "&algoliaAppId=").concat(algoliaAppId, "&modelId=").concat(model.id, "&apiKey=").concat(appState.user.apiKey),
                                disableProxy: true, // proxy has an issue with the POST request body
                            };
                            existingAlgoliaHookIndex = -1;
                            for (i = 0; i < model.webhooks.length; i++) {
                                currentHookPath = (_a = model.webhooks[i].url) === null || _a === void 0 ? void 0 : _a.split('?')[0];
                                newHookPath = newWebhook.url.split('?')[0];
                                if (currentHookPath === newHookPath) {
                                    existingAlgoliaHookIndex = i;
                                    break; // Exit loop early once a match is found
                                }
                            }
                            if (existingAlgoliaHookIndex >= 0) {
                                model.webhooks[existingAlgoliaHookIndex] = newWebhook;
                            }
                            else {
                                model.webhooks.push(newWebhook);
                            }
                            return [4 /*yield*/, appState.models.update(model, false)];
                        case 2:
                            _b.sent();
                            appState.snackBar.show('Algolia webhook saved');
                            return [2 /*return*/];
                    }
                });
            }); };

            Builder.register('plugin', {
                id: pluginId,
                name: 'Algolia',
                settings: [
                    {
                        name: 'algoliaKey',
                        type: 'text',
                        defaultValue: true,
                    },
                    {
                        name: 'algoliaAppId',
                        type: 'text',
                        defaultValue: true,
                    },
                ],
                ctaText: 'Save',
                onSave: function (actions) {
                    return __awaiter(this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: 
                                // update plugin setting
                                return [4 /*yield*/, actions.updateSettings({
                                        hasConnected: true,
                                    })];
                                case 1:
                                    // update plugin setting
                                    _a.sent();
                                    appState.dialogs.alert('Plugin settings saved.');
                                    return [2 /*return*/];
                            }
                        });
                    });
                },
            });
            Builder.register('app.onLoad', function (_a) {
                var triggerSettingsDialog = _a.triggerSettingsDialog;
                return __awaiter(void 0, void 0, void 0, function () {
                    var pluginSettings, hasConnected;
                    var _b;
                    return __generator(this, function (_c) {
                        switch (_c.label) {
                            case 0:
                                pluginSettings = (_b = appState.user.organization.value.settings.plugins) === null || _b === void 0 ? void 0 : _b.get(pluginId);
                                hasConnected = pluginSettings === null || pluginSettings === void 0 ? void 0 : pluginSettings.get('hasConnected');
                                if (!!hasConnected) return [3 /*break*/, 2];
                                return [4 /*yield*/, triggerSettingsDialog(pluginId)];
                            case 1:
                                _c.sent();
                                _c.label = 2;
                            case 2: return [2 /*return*/];
                        }
                    });
                });
            });
            Builder.register('model.action', {
                name: 'Sync to Algolia',
                showIf: function () {
                    return appState.user.can('admin');
                },
                onClick: function (model) {
                    return __awaiter(this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, appState.dialogs.confirm("This will sync all current and future entries in the \"".concat(model.name, "\" model to Algolia."), 'Continue')];
                                case 1:
                                    if (!(_a.sent())) {
                                        return [2 /*return*/];
                                    }
                                    appState.globalState.showGlobalBlockingLoadingIndicator = true;
                                    return [4 /*yield*/, syncToAlgolia(model.name)];
                                case 2:
                                    _a.sent();
                                    return [4 /*yield*/, createWebhook(model)];
                                case 3:
                                    _a.sent();
                                    appState.globalState.showGlobalBlockingLoadingIndicator = false;
                                    return [2 /*return*/];
                            }
                        });
                    });
                },
            });

        }
    };
});
//# sourceMappingURL=plugin.system.js.map
